/*
 * tdssdh.h
 *	Sampling Data Header of 9270 VLBI data-sampler (USB device)
 *	written by KIYOHARA Takashi <kiyohara@soum.co.jp>
 *	$SOUM$
 */

#ifndef _TDSSDH_H_
#define _TDSSDH_H_

#include <asm/byteorder.h>   
/*
 *  use endian.h instead of asm/byteorder.h according to gcc's warning message 
 */
/* #include <endian.h> */               

#define UTDSSDH_VERSION_MAJOR	1
#define UTDSSDH_VERSION_MINOR	0

struct tdssdh {
	uint16_t syncptn0;		/* 0xffff */
	uint16_t syncptn1;		/* 0xffff */
	uint16_t totalsec0;
#if defined(__BIG_ENDIAN_BITFIELD)
	uint16_t syncptn2 : 8;
	uint16_t bitwidth : 2;
	uint16_t fsample : 4;
	uint16_t chmode : 1;
	uint16_t totalsec1 : 1;
	uint16_t year : 7;
	uint16_t totalday : 9;
#endif
#if defined(__LITTLE_ENDIAN_BITFIELD)
	uint16_t totalsec1 : 1;
	uint16_t chmode : 1;
	uint16_t fsample : 4;
	uint16_t bitwidth : 2;
	uint16_t syncptn2 : 8;
	uint16_t totalday : 9;
	uint16_t year : 7;
#endif

	/* Continue here version number and aux fields */
} __attribute__((__packed__));
typedef struct tdssdh *tdssdh_t;

struct tdsaux {
#if defined(__BIG_ENDIAN_BITFIELD)
	uint16_t major : 4;
	uint16_t minor : 4;
	uint16_t size : 8;
#endif
#if defined(__LITTLE_ENDIAN_BITFIELD)
	uint16_t size : 8;
	uint16_t minor : 4;
	uint16_t major : 4;
#endif
	char field[256];
} __attribute__((__packed__));
typedef struct tdsaux *tdsaux_t;

#endif	/* _TDSSDH_H_ */
